//****************************************************************************
// @Module        Project Settings
// @Filename      MAIN.C
// @Project       R.dav
//----------------------------------------------------------------------------
// @Controller    Infineon XC164CM-8F40
//
// @Compiler      Keil
//
// @Codegenerator 1.0
//
// @Description   This file contains the project initialization function.
//
//----------------------------------------------------------------------------
// @Date          4/11/2012 8:08:26 
//
//****************************************************************************

// USER CODE BEGIN (MAIN_General,1)

// USER CODE END



//****************************************************************************
// @Project Includes
//****************************************************************************

#include "MAIN.H"

// USER CODE BEGIN (MAIN_General,2)
	 #include <stdio.H>
	  #include <stdlib.H>
	  #include <string.h>
// USER CODE END


//****************************************************************************
// @Macros
//****************************************************************************

// USER CODE BEGIN (MAIN_General,3)

// USER CODE END


//****************************************************************************
// @Defines
//****************************************************************************

// USER CODE BEGIN (MAIN_General,4)

// USER CODE END


//****************************************************************************
// @Typedefs
//****************************************************************************

// USER CODE BEGIN (MAIN_General,5)
 
  typedef  struct
{
  unsigned int    bit0      : 1;
  unsigned int    bit1      : 1;
  unsigned int    bit2      : 1;
  unsigned int    bit3      : 1;
  unsigned int    bit4      : 1;
  unsigned int    bit5      : 1;
  unsigned int    bit6      : 1;
  unsigned int    bit7      : 1;
  unsigned int    bit8      : 1;
  unsigned int    bit9      : 1;
  unsigned int    bit10     : 1;
  unsigned int    bit11     : 1;
  unsigned int    bit12     : 1;
  unsigned int    bit13     : 1;
  unsigned int    bit14     : 1;
  unsigned int    bit15     : 1;
}  T;




// USER CODE END


//****************************************************************************
// @Imported Global Variables
//****************************************************************************

// USER CODE BEGIN (MAIN_General,6)

// USER CODE END


//****************************************************************************
// @Global Variables
//****************************************************************************

// USER CODE BEGIN (MAIN_General,7)

  
 struct g {
 int gen ;
 //int boy: 1;
 //int girl: 1;
 }gender;

 struct p { 
    struct  gender;   
    int m;
    union {
    char boy_name[20];
    char girl_name[20];
    } name;
    }person;
   
    void DataEnter(struct p *ptr);
    void DataDisplay(struct p *ptr);

   
  char yes [7];
   
  char  c [3];

 #define BOY ((T*)(&(gender.gen)))->bit0

 #define GIRL ((T*)(&gender.gen))->bit1                                 
// USER CODE END


//****************************************************************************
// @External Prototypes
//****************************************************************************

// USER CODE BEGIN (MAIN_General,8)

// USER CODE END


//****************************************************************************
// @Prototypes Of Local Functions
//****************************************************************************

// USER CODE BEGIN (MAIN_General,9)
 

   
	 

	 
	 
	 
	                         
// USER CODE END


//****************************************************************************
// @Function      void MAIN_vInit(void) 
//
//----------------------------------------------------------------------------
// @Description   This function initializes the microcontroller.
//
//----------------------------------------------------------------------------
// @Returnvalue   None
//
//----------------------------------------------------------------------------
// @Parameters    None
//
//----------------------------------------------------------------------------
// @Date          4/11/2012
//
//****************************************************************************

// USER CODE BEGIN (Init,1)

// USER CODE END

void MAIN_vInit(void)
{
  // USER CODE BEGIN (Init,2)

  // USER CODE END

  ///  -----------------------------------------------------------------------
  ///  Configuration of the System Clock:
  ///  -----------------------------------------------------------------------
  ///  - VCO clock used, input clock is connected
  ///  - input frequency is 8 MHz
  ///  - VCO output frequency 150 .. 200 MHz
  ///  - system clock is 40 MHz

  MAIN_vUnlockProtecReg();       // unlock write security
  PLLCON         =  0x7844;      // load PLL control register


  //// -----------------------------------------------------------------------
  //// Begin of Important Settings for the Start-Up File
  //// -----------------------------------------------------------------------
  ///  All following settings must be set in the start-up file. You can use 
  ///  DAvE's project file (*.dpt) to include this register values into your 
  ///  compiler EDE.

    ///  ---------------------------------------------------------------------
    ///  Initialization of the CPUCON1 Register:
    ///  ---------------------------------------------------------------------
    ///  - space between two vectors is 2 words
    ///  - DISWDT executable until End of Init
    ///  - segmentation is enabled
    ///  - switch context is interruptible
    ///  - branch prediction is enabled
    ///  - zero cycle jump function is enabled

    //// this register must be set in the start-up file
    //// CPUCON1  =  0x0007

    ///  ---------------------------------------------------------------------
    ///  Initialization of the VECSEG Register:
    ///  ---------------------------------------------------------------------
    ///  - start from internal program memory

    //// this register must be set in the start-up file
    //// VECSEG  =  0x00C0

    ///  ---------------------------------------------------------------------
    ///  Initialization of the SYSCON0 Register:
    ///  ---------------------------------------------------------------------

    //// this register must be set in the start-up file
    //// SYSCON0  =  0x0000

    ///  ---------------------------------------------------------------------
    ///  Initialization of the SYSCON1 Register:
    ///  ---------------------------------------------------------------------
    ///  clock prescaler for system is fpll / 1
    ///  clock prescaler for PD+ bus is fcpu / 1

    //// this register must be set in the start-up file
    //// SYSCON1  =  0x0000

    ///  ---------------------------------------------------------------------
    ///  Initialization of the SYSCON3 Register:
    ///  ---------------------------------------------------------------------

    //// this register must be set in the start-up file
    //// SYSCON3  =  0x0000

  //// -----------------------------------------------------------------------
  //// End of Important Settings for the Start-Up File
  //// -----------------------------------------------------------------------


  //   -----------------------------------------------------------------------
  //   Initialization of the Peripherals:
  //   -----------------------------------------------------------------------

  //   initializes the Asynchronous/Synchronous Serial Interface (ASC0)
  ASC0_vInit();

  // USER CODE BEGIN (Init,3)

  // USER CODE END

 
  PSW_IEN        =  1;          

} //  End of function MAIN_vInit


//****************************************************************************
// @Function      void MAIN_vUnlockProtecReg(void) 
//
//----------------------------------------------------------------------------
// @Description   This function makes it possible to write one protected 
//                register. After calling of this function and write on the 
//                protected register is the security level set to low 
//                protected mode.
//
//----------------------------------------------------------------------------
// @Returnvalue   None
//
//----------------------------------------------------------------------------
// @Parameters    None
//
//----------------------------------------------------------------------------
// @Date          4/11/2012
//
//****************************************************************************

// USER CODE BEGIN (UnlockProtecReg,1)

// USER CODE END

void MAIN_vUnlockProtecReg(void)
{
  uword uwPASSWORD;

  if((SCUSLS & 0x1800) == 0x0800)      // if low protected mode
  {

    uwPASSWORD = SCUSLS & 0x00FF;
    uwPASSWORD = (~uwPASSWORD) & 0x00FF;
    SCUSLC = 0x8E00 | uwPASSWORD;      // command 4

  }  // end if low protected mode

  if((SCUSLS & 0x1800) == 0x1800)      // if write protected mode
  {
    SCUSLC = 0xAAAA;                   // command 0
    SCUSLC = 0x5554;                   // command 1

    uwPASSWORD = SCUSLS & 0x00FF;
    uwPASSWORD = (~uwPASSWORD) & 0x00FF;

    SCUSLC = 0x9600 | uwPASSWORD;      // command 2
    SCUSLC = 0x0800;                   // command 3; new PASSWOR is 0x00

    uwPASSWORD = SCUSLS & 0x00FF;
    uwPASSWORD = (~uwPASSWORD) & 0x00FF;
    SCUSLC = 0x8E00 | uwPASSWORD;      // command 4

  }  // end if write protected mode

} //  End of function MAIN_vUnlockProtecReg


//****************************************************************************
// @Function      void main(void) 
//
//----------------------------------------------------------------------------
// @Description   This is the main function.
//
//----------------------------------------------------------------------------
// @Returnvalue   None
//
//----------------------------------------------------------------------------
// @Parameters    None
//
//----------------------------------------------------------------------------
// @Date          4/11/2012
//
//****************************************************************************

// USER CODE BEGIN (Main,1)

 



 


// USER CODE END

void main(void)
{
  // USER CODE BEGIN (Main,2)

 
	
				
 
  // USER CODE END

  MAIN_vInit();

  // USER CODE BEGIN (Main,4)

 

    
    DataEnter(&person);
    DataDisplay(&person);
   
    while(1);

  

  

           

  }
 

  
  
  //=================================================================================


   /* function definition */
    void DataEnter(struct p *ptr)
    {

     
 
   	
    printf("are you a boy ? (Yes or No)\n");
    gets(yes,5);
    if ((yes[0] == 'Y') ||
    (yes[0] == 'y')){
    printf("How old are you?\n");
	scanf("%d", &(ptr->m));
	printf("Enter your  name :\n");
	gets(c,2);	 //falls the remaining character in the i/o stream after scanf() execution in the rubbish!!!
    gets(ptr->name.boy_name,20);
    BOY =1 ;               // ptr->gender.boy = 1;
    GIRL =0;               // ptr->gender.girl = 0;
    } 
	else {
    printf("are you a girl? (Yes or No)\n");
    gets(yes,5);
    if ((yes[0] == 'Y') ||
    (yes[0] == 'y')){
    printf("how old are you?:\n");
	scanf("%d", &ptr->m);
	printf("Enter your  name ?\n");
    gets(c,2);	 //falls the remaining character in the i/o stream after scanf() execution in the rubbish!!!
    gets(ptr->name.girl_name,20);
    BOY=0;                  //ptr->gender.boy = 0;
    GIRL=1;                 //ptr->gender.girl = 1;
    } 
    }

	}
 


    void DataDisplay(struct p *ptr)
    {
 

    if (BOY==1 &&  GIRL==0)           //(ptr->gender.boy && !ptr->gender.girl)
    printf("You are a boy. Your  name is: %s, YOUR AGE IS: %u \n",
    ptr->name.boy_name,ptr->m );


    else if (BOY==0 && GIRL==1)      //(!ptr->gender.boy && ptr->gender.girl)
    printf("You are a girl.Your name is: %s, your age is:%u \n",
    ptr->name.girl_name,ptr->m );


    else
    printf("You are neither a boy nor a girl.\n");
    printf("\Thanks and Bye!\n");
    }



 
 
	  
  

 
    
   





 








  // USER CODE END

 //  End of function main



// USER CODE BEGIN (MAIN_General,10)

// USER CODE END

